#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum EnumFilterOperator {
    #[serde(rename = "IS_IN")]
    IsIn,
    #[serde(rename = "IS_NOT_IN")]
    IsNotIn,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl EnumFilterOperator {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            EnumFilterOperator::IsIn => "IS_IN",
            EnumFilterOperator::IsNotIn => "IS_NOT_IN",
            EnumFilterOperator::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for EnumFilterOperator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for EnumFilterOperator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for EnumFilterOperator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<EnumFilterOperator, conjure_object::plain::ParseEnumError> {
        match v {
            "IS_IN" => Ok(EnumFilterOperator::IsIn),
            "IS_NOT_IN" => Ok(EnumFilterOperator::IsNotIn),
            v => v.parse().map(|v| EnumFilterOperator::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for EnumFilterOperator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<EnumFilterOperator, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the EnumFilterOperator enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
